(in-package :movement-three)

(define-meter *code-methods-found* image code-methods-found)
(defun compile-all-methods (application &key (compile-arguments '()))
  (let ((*compilation-unit*
          (make-compilation-unit :compile-arguments compile-arguments))
        (seen-methods (make-hash-table))
        (seen (make-hash-table)))
    (labels ((walk-object (object)
               (unless (gethash object seen)
                 (setf (gethash object seen) t)
                 (let ((type (wider-type-of object)))
                   ;; MAP-METHODS doesn't give or take the right information to not
                   ;; special-case _classes_ (not class definitions) in the heap
                   ;; so this will have to do.
                   (if (and (record-p type) (typep (record-source type) 'utena-class))
                       (walk-class type)
                       (map-methods (lambda (n m) (walk-method m n type)) type))
                   (map-slot-values #'walk-object object))))
             (walk-class-definition (class-definition enclosing-type)
               (let ((receiver-type (instance-type class-definition enclosing-type)))
                 (map-methods (lambda (n m) (walk-method m n receiver-type))
                              class-definition)))
             (walk-class (type)
               (let ((def (class-definition (record-source type))))
                 (walk-method (haaden-two::constructor-method def)
                              (haaden-two::constructor-name def)
                              type)
                 (walk-class-definition def (enclosing-type (record-source type)))))
             (walk-method (method name receiver-type)
               (declare (ignore name))
               (unless (gethash method seen-methods)
                 (setf (gethash method seen-methods) receiver-type)
                 (let ((*pass* "Image"))
                   (mumble "Compiling " method " for " receiver-type))
                 (let* ((argument-types
                          (cons receiver-type
                                (make-list (1- (method-argument-count method)) :initial-element +top+)))
                        ;; FIND-FUNCTION will enqueue the method to be compiled;
                        ;; we could compile it now, but that makes SB-SPROF output
                        ;; harder to follow.
                        (function-info (find-function method argument-types :create-if-missing t)))
                   (setf (fun-method function-info) method))
                 (when (typep method 'haaden-two:code-method)
                   (meter-tick *code-methods-found*)
                   (let ((ar-type (activation-record-types method receiver-type)))
                     (dolist (i (haaden-two::instructions method))
                     (when (typep i 'haaden-two:make-class)
                       (walk-class-definition (haaden-two:class-definition i) ar-type))
                       (when (typep i 'haaden-two:literal)
                         (walk-object (haaden-two::value i)))))))))
      (walk-object application))
    (process-work-list *compilation-unit*)
    *compilation-unit*))

(defgeneric map-methods (function type))
(defmethod map-methods (function (r record))
  (map-methods function (class-definition (record-source r))))
(defmethod map-methods (function (def haaden-two:class-definition))
  (dolist (m (haaden-two::methods def))
    (funcall function (haaden-two::name (haaden-two:info m)) m)))

(defgeneric map-slot-values (function object))
(defmethod map-slot-values (function (object haaden-two::instance))
  (map 'nil function (haaden-two::storage object)))
(defmethod map-slot-values (function (i integer))
  (declare (ignore function)))
(defmethod map-slot-values (function (s symbol))
  (declare (ignore function)))
(defmethod map-slot-values (function (s string))
  (declare (ignore function)))
(defmethod map-slot-values (function (c haaden-two:class))
  (unless (null (haaden-two::enclosing-object c))
    (funcall function (haaden-two::enclosing-object c))))
